#include "cv.h"

class Comorph {

 private:

	 int threshold;
	 IplConvKernel *ex;
	 IplConvKernel *square;
	 IplConvKernel *lozeng;
	 IplConvKernel *cross;
	 int *exp;
	 int *squarep;
	 int *lozengp;
	 int *crossp;
	 IplImage *tmp1;
	 IplImage *tmp2;

public:

	Comorph() {

		exp= new int[25];
		exp[0]= 1; exp[1]= 0; exp[2]= 0; exp[3]= 0; exp[4]= 1;
		exp[5]= 0; exp[6]= 1; exp[7]= 0; exp[8]= 1; exp[9]= 0;
		exp[10]=0; exp[11]=0; exp[12]=1; exp[13]=0; exp[14]=0;
		exp[15]=0; exp[16]=1; exp[17]=0; exp[18]=1; exp[19]=0;
		exp[20]=1; exp[21]=0; exp[22]=0; exp[23]=0; exp[24]=1;
		ex= cvCreateStructuringElementEx(5, 5, 2, 2, CV_SHAPE_CUSTOM, exp);

		squarep= new int[25];
		squarep[0]= 1; squarep[1]= 1; squarep[2]= 1; squarep[3]= 1; squarep[4]= 1;
		squarep[5]= 1; squarep[6]= 1; squarep[7]= 1; squarep[8]= 1; squarep[9]= 1;
		squarep[10]=1; squarep[11]=1; squarep[12]=1; squarep[13]=1; squarep[14]=1;
		squarep[15]=1; squarep[16]=1; squarep[17]=1; squarep[18]=1; squarep[19]=1;
		squarep[20]=1; squarep[21]=1; squarep[22]=1; squarep[23]=1; squarep[24]=1;
		square= cvCreateStructuringElementEx(5, 5, 2, 2, CV_SHAPE_CUSTOM, squarep);

		lozengp= new int[25];
		lozengp[0]= 0; lozengp[1]= 0; lozengp[2]= 1; lozengp[3]= 0; lozengp[4]= 0;
		lozengp[5]= 0; lozengp[6]= 1; lozengp[7]= 1; lozengp[8]= 1; lozengp[9]= 0;
		lozengp[10]=1; lozengp[11]=1; lozengp[12]=1; lozengp[13]=1; lozengp[14]=1;
		lozengp[15]=0; lozengp[16]=1; lozengp[17]=1; lozengp[18]=1; lozengp[19]=0;
		lozengp[20]=0; lozengp[21]=0; lozengp[22]=1; lozengp[23]=0; lozengp[24]=0;
		lozeng= cvCreateStructuringElementEx(5, 5, 2, 2, CV_SHAPE_CUSTOM, lozengp);

		crossp= new int[25];
		crossp[0]= 0; crossp[1]= 0; crossp[2]= 1; crossp[3]= 0; crossp[4]= 0;
		crossp[5]= 0; crossp[6]= 0; crossp[7]= 1; crossp[8]= 0; crossp[9]= 0;
		crossp[10]=1; crossp[11]=1; crossp[12]=1; crossp[13]=1; crossp[14]=1;
		crossp[15]=0; crossp[16]=0; crossp[17]=1; crossp[18]=0; crossp[19]=0;
		crossp[20]=0; crossp[21]=0; crossp[22]=1; crossp[23]=0; crossp[24]=0;
		cross= cvCreateStructuringElementEx(5, 5, 2, 2, CV_SHAPE_CUSTOM, crossp);

		tmp1=tmp2=0;
	}

	void allocateBuffers(IplImage *src) {

		cvReleaseImage(&tmp1);
		cvReleaseImage(&tmp2);

		tmp1= cvCreateImage(cvSize(src->width,src->height), IPL_DEPTH_8U, 1);
		tmp2= cvCreateImage(cvSize(src->width,src->height), IPL_DEPTH_8U, 1);
	}

	void findCorners(IplImage *src, IplImage *dst,int threshold=-1) {

		cvDilate(src,tmp1,cross);
		cvErode(tmp1,tmp2,lozeng);
		cvDilate(src,dst,ex);
		cvErode(dst,tmp1,square);
        cvAbsDiff(tmp2,tmp1,dst);
		if (threshold>0) 
			cvThreshold(dst,dst,threshold,255,CV_THRESH_BINARY);

//		cvCopy(dst,tmp1);
//		cvMorphologyEx(tmp1,dst,tmp2,square,CV_MOP_TOPHAT,3); 
	}

	~Comorph() {

		cvReleaseStructuringElement(&ex);
		cvReleaseStructuringElement(&square);
		cvReleaseStructuringElement(&lozeng);
		cvReleaseStructuringElement(&cross);
		delete[] exp;
		delete[] squarep;
		delete[] lozengp;
		delete[] crossp;
		cvReleaseImage(&tmp1);
		cvReleaseImage(&tmp2);
	}
};