// derivateDlg.cpp : implementation file
//

#include "stdafx.h"
#include "derivate.h"
#include "derivateDlg.h"
#include ".\derivatedlg.h"
#include "Derivatives.h"
#include <vector>
using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CderivateDlg dialog



CderivateDlg::CderivateDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CderivateDlg::IDD, pParent)
	, varmin(0)
	, angle(0)
	, minangle(0)
	, thr(0)
	, radius(0)
	, sigma(0)
	, maxangle(0)
	, wwidth(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CderivateDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT9, radius);
	DDX_Control(pDX, IDC_CHECK1, binary);
}

BEGIN_MESSAGE_MAP(CderivateDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON4, OnBnClickedButton4)
END_MESSAGE_MAP()


// CderivateDlg message handlers

BOOL CderivateDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	cvNamedWindow("Image",1);
	image=0;
	result=0;
	ori=0;

	radius= 20;
	sigma= 0.8;
	varmin=600;
	angle= 10.;
	wwidth=10.;
	thr=0.8;
	minangle= 50;
	maxangle= 105;

	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CderivateDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CderivateDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CderivateDlg::OnBnClickedButton1()
{
  CFileDialog dlg(TRUE, _T("*.bmp"), "",
    OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,
    "image files (*.bmp; *.jpg) |*.bmp;*.jpg|All Files (*.*)|*.*||",NULL);

  char title[]= {"Open Image"};
  dlg.m_ofn.lpstrTitle= title;

  if (dlg.DoModal() == IDOK) { 

    CString path= dlg.GetPathName();  // contain the selected filename
	cvReleaseImage(&image);
	cvReleaseImage(&ori);
	ori= cvLoadImage(path,-1);

	if (ori->nChannels > 1) {

		image=cvCreateImage(cvSize(ori->width,ori->height),IPL_DEPTH_8U,1);
		cvCvtColor(ori, image, CV_BGR2GRAY);

	} else {

		image=cvCloneImage(ori);
	}

	cvReleaseImage(&result);
	result= cvCloneImage(image);
	cvShowImage("Image", ori);
	comorph.allocateBuffers(ori);
  }
}

void CderivateDlg::OnBnClickedButton2()
{
	UpdateData(TRUE);
	comorph.findCorners(image,result,radius);
	if (binary.GetCheck())
		cvOr(image,result,result);
	cvShowImage("Image", result);
}

void CderivateDlg::OnBnClickedButton4()
{
  CFileDialog dlg(FALSE, _T(".bmp"), "", 
                  OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY,
    "image files (*.bmp; *.jpg) |*.bmp;*.jpg|All Files (*.*)|*.*||",NULL);

  char title[]= {"Save sequence"};
  dlg.m_ofn.lpstrTitle= title;

  if (dlg.DoModal() == IDOK) {

    CString path= dlg.GetPathName();

	cvSaveImage(path,result);
  }			
}
